-- MySQL script to create tables for LiveAlbum

CREATE DATABASE IF NOT EXISTS livealbum;

USE livealbum;

CREATE TABLE medias (
	id		VARCHAR(32)		NOT NULL,
	album_id   	VARCHAR(32)		NOT NULL,
	filename	VARCHAR(255)   		NOT NULL,
        counter         MEDIUMINT UNSIGNED  	DEFAULT '0',
	rate		TINYINT			DEFAULT '0',
	title		TEXT,
	description	TEXT,
        created         DATETIME,
        PRIMARY KEY (id)
);

CREATE TABLE comments (
	id		VARCHAR(32)		NOT NULL,
	comment		TEXT,
	name		VARCHAR(64),
	time		DATETIME		NOT NULL,
	ip		VARCHAR(128),
        KEY id (id)
);

CREATE TABLE albums (
	id		VARCHAR(32)		NOT NULL,
	directory	TEXT			NOT NULL,
	created		DATETIME,
	PRIMARY KEY (id)
);
