<?php
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_ALBUM', true);

if (!isset($HTTP_GET_VARS['id']) && !isset($HTTP_POST_VARS['id']))
{
        msg_die("parameter id missing", '', __FILE__, __LINE__);
}
$media_id = isset($HTTP_GET_VARS['id']) ? $HTTP_GET_VARS['id'] : $HTTP_POST_VARS['id'];

include($livealbum_dir . 'page_header.php');

$template->set_file('body', 'show.html');
$i = $medias->get_i_by_id($media_id);
$media_info = $medias->get_media_info($i);
$medium_size_image = $medias->get_medium_filename($media_info['filename']);
//$media_link = $media_info['filename'];

if (strpos($media_info['filename'], '.AVI') ||
    strpos($media_info['filename'], '.avi'))
{
	$template->set_var('V_MEDIA', '<a href="' . $medium_size_image . '"><img src="' . image_link($medias->get_thumbnail_filename($media_info['filename'])) . '" border="0"></a>');
}
else $template->set_var('V_MEDIA', '<img src="' . image_link($medium_size_image) . '">');

// increase the counter
$sql = "SELECT counter FROM medias
	WHERE id = '$media_id'";

if (!($result = $db->sql_query($sql)))
{
	msg_die("Error fetching media data", '', __FILE__, __LINE__, $sql);
}
if (!($row = $db->sql_fetchrow($result)))
{
	msg_die("some fancy error", '', __FILE__, __LINE__, $sql);
}
$counter = $row['counter'];
$counter++;

$template->set_var('V_COUNTER', $counter);
$template->set_var('V_COUNTER_UNIT', ($counter == 1) ? 'time' : 'times');

$sql = "UPDATE medias SET
	counter = $counter
        WHERE id = '$media_id'";
if (!($result = $db->sql_query($sql)))
{
	msg_die("Error updating media data", '', __FILE__, __LINE__, $sql);
}

$prev_info = $medias->get_media_info($i-1);
$next_info = $medias->get_media_info($i+1);
if ($prev_info != false)
{
	$template->set_var('V_PREV_LINK_BEGIN', '<a href="index.php?mode=show&id=' . $prev_info['id'] . '">');
	$template->set_var('V_PREV_LINK_END', '</a>');
}
else
{
	$template->set_var('V_PREV_LINK_BEGIN', '');
	$template->set_var('V_PREV_LINK_END', '');
}
if ($next_info != false)
{
	$template->set_var('V_NEXT_LINK_BEGIN', '<a href="index.php?mode=show&id=' . $next_info['id'] . '">');
	$template->set_var('V_NEXT_LINK_END', '</a>');
}
else
{
	$template->set_var('V_NEXT_LINK_BEGIN', '');
	$template->set_var('V_NEXT_LINK_END', '');
}
$template->set_var('V_NEXT_ID', $next_info['id']);
$template->set_var('V_MEDIA_ID', $media_id);
$template->set_var('V_DIR', $gallery_dir);
$upper_film_link = '';
$lower_film_link = '';
if (strstr($media_info['filename'], '.AVI') ||
    strstr($media_info['filename'], '.avi'))
{
	$upper_film_link = '<img src="' . $configs['livealbum_url'] . 'templates/default/film_upper_edge.gif" border="0">';
        $lower_film_link = '<img src="' . $configs['livealbum_url'] . 'templates/default/film_lower_edge.gif" border="0">';
}
$template->set_var('V_FILM_UPPER', $upper_film_link);
$template->set_var('V_FILM_LOWER', $lower_film_link);

$exif_data = get_image_exif_data($media_info['filename']);
$template->set_var('V_ORIGINAL_FILE', $media_info['filename']);
$template->set_var('V_ORIGINAL_FILE_LINK', image_link($media_info['filename']));
$image_size = get_image_geometry($media_info['filename']);
$template->set_var('V_ORIGINAL_SIZE', ($image_size != false) ? '(' . $image_size . ')' : '');

$template->set_block('body', 'EXIF_DATA', 'exif_data');
if (!isset($exif_data['Model']))
	$template->set_var('exif_data', '');
else
{
	$template->set_var('V_CAPTURE_DATE', $exif_data['Image Capture Date']);
	$template->set_var('V_CAMERA_MODEL', $exif_data['Model']);
	$template->set_var('V_EXPOSURE_TIME', $exif_data['Exposure Time'] ? $exif_data['Exposure Time'] : $exif_data['Shutter Speed Value']);
	$template->set_var('V_APERTURE', $exif_data['Aperture']);
	$template->parse('exif_data', 'EXIF_DATA', true);
}

// show comments
$template->set_block('body', 'EACH_COMMENT', 'comments');
$sql = "SELECT * FROM comments
	WHERE id = '$media_id'
        ORDER BY TIME";
if (!($result = $db->sql_query($sql)))
{
	msg_die("Error fetching media data", '', __FILE__, __LINE__, $sql);
}
$comment_data = array();
while ($row = $db->sql_fetchrow($result))
{
	$comment_data[] = $row;
}
$comments = count($comment_data);
if ($comments == 0)
{
	$template->set_var('comments', '');
}
for ($i = 0; $i < $comments; $i++)
{
	$template->set_var('V_COMMENT', $comment_data[$i]['comment']);
        $template->set_var('V_COMMENT_NAME', $comment_data[$i]['name']);
        $template->set_var('V_COMMENT_TIME', $comment_data[$i]['time']);
        $template->parse('comments', 'EACH_COMMENT', true);
}

if ($configs['comments_enabled'] == false)
{
	$template->set_var('V_GIVE_COMMENT_ENABLED_BEGIN', '<!--');
        $template->set_var('V_GIVE_COMMENT_ENABLED_END', '-->');
}
else
{
	$template->set_var('V_GIVE_COMMENT_ENABLED_BEGIN', '');
        $template->set_var('V_GIVE_COMMENT_ENABLED_END', '');
}

$template->pparse('out', 'body');

?>
