<?php
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

function init()
{
        global $template, $configs, $livealbum_dir;
        $template_path = 'templates/';
        $template_name = $configs['theme'];
        $dir = $livealbum_dir . $template_path . $template_name;
        $template = new Template($dir, 'keep');

        if (!file_exists($configs['convert_bin']))
        {
                msg_die("convert binary '" . $configs['convert_bin'] . "' not found! Please install ImageMagick toolkit.", __LINE__, __FILE__);
        }
        //else if (!file_exists($configs['mencoder_bin']))
        //{
        //        msg_die("mencoder binary '" . $configs['mencoder_bin'] . "' not found! Please install MPlayer (with mencoder).", __LINE__, __FILE__);
        //}
}

function msg_die($msg_text = '', $err_line = '', $err_file = '', $sql = '')
{
        global $db;

        // do this only once
        if (defined('HAS_DIED'))
        {
                die("msg_die() called multiple times.");
        }
        define(HAS_DIED, 1);

        $sql_store = $sql;
        $sql_error = $db->sql_error();
        if ($sql_error['message'] != '')
        {
        	$msg_text .= '<br><br>SQL Error: ' . $sql_error['message'];
        }

        echo "<html>\n<body>\n" . $msg_title . "\n<br /><br />\n" . $msg_text . "</body>\n</html>";
        exit;
}

function redirect($url)
{
        global $db, $configs, $HTTP_SERVER_VARS;

        if (!empty($db))
        {
                $db->sql_close();
        }

        $server_protocol = $configs['cookie_secure'] ? 'https://' : 'http://';
        $server = $HTTP_SERVER_VARS['HTTP_HOST'];
        $path = $HTTP_SERVER_VARS['REQUEST_URI'];
        $pos = strrpos($path, "/");
        $path = substr($path, 0, $pos + 1);
        $location = $server_protocol . $server . $path . $url;
        // use http/1.1 redirecting
        header('Location: ' . $location);
        exit;
}

function get_album_id()
{
        global $db, $configs;
        $album_id = '';
        $file = @fopen($configs['album_id_file'], "r");
        if ($file != false)
        {
                $album_id = fgets($file);
                fclose($file);
                return $album_id;
        }
	// doesnt exist, ssooooo let's create a new one
	$album_id = md5(uniqid(""));
        $file = fopen($configs['album_id_file'], "w");
        if ($file == false)
                msg_die("Could not create file '" .
                $configs['album_id_file'] . "', make sure that I have write permission to your directory.", __LINE__, __FILE__);
        fwrite($file, $album_id);
        fclose($file);
        return $album_id;
}

function scale_image($original, $target, $size)
{
        global $configs;
        $geometry = get_image_geometry($original);
        if ($geometry == false)
                return false; // couldn't fetch image data
        parse_geometry($geometry, $image_width, $image_height);
        parse_geometry($size, $wanted_width, $wanted_height);

        // if image is rotated 90 degrees, let's scale it right
        if ($image_width < $image_height)
                $size = $wanted_height . 'x' . $wanted_width;

        $command = $configs['convert_bin'] . ' -size ' . $size . ' "' . $original . '" -resize ' . $size . ' "' . $target . '"';
        system($command);
        if (is_file($target))
        {
                chmod($target, $configs['media_permissions']);
                return true;
        }
        return false;
}

function encode_divx($original, $target)
{
        // mencoder may segfault when encoding in the
        // current directory, so lets move to do the job
        // at /tmp (really sick, huh)
        global $configs;
        $cwd = getcwd();
        $original = $cwd . '/' . $original;
        $target = $cwd . '/' . $target;
        chdir('/tmp');
        $command = $configs['mencoder_bin'] . ' "' . $original . '" -oac copy -ovc divx4 -o "' . $target . '"';
        exec($command, $output, $value);
        chdir($cwd);
        if ($value != 0)
        {
        	echo "encoding divx '" . $target . "' failed (returned value $value). try to run command:<br>$command<br> as user www-data and check the error. ";
                echo "make sure that user www-data has correct mplayer configurations.<br>";
                return false;
        }
        if (is_file($target))
        {
                chmod($target, $configs['media_permissions']);
                return true;
        }
        return false;
}

function make_thumbnail_from_video($original, $target)
{
        global $configs;
        $command = $configs['convert_bin'] . ' "' . $original . '" -resize ' . $configs['thumbnail_size'] . ' "' . $target . '"';
        system($command);
        if (is_file($target))
        {
                chmod($target, $configs['media_permissions']);
                return true;
        }
        return false;
}

function parse_geometry($size, &$width, &$height)
{
        $geometry = explode('x', $size);
        $width = $geometry[0];
        $height = $geometry[1];
}

function get_image_exif_data($file)
{
        global $configs;
        $exif = array();
        $command = $configs['metacam_bin'] . ' "' . $file . '"';
        exec($command, $output, $value);
        if ($value != 0)
                return false; // couldn't fetch exif data
        for ($i = 0; $i < count($output); $i++)
        {
                $line = explode(": ", $output[$i]);
                $key = trim($line[0]);
                $value = trim($line[1]);
                if ($key == "Exif Image Width")
                        $width = explode(' ', $value);
                else if ($key == "Exif Image Height")
                        $height = explode(' ', $value);
                if (strlen($key) && strlen($value))
                        $exif[$key] = $value;
        }
        $exif['Size'] = $width[0] . 'x' . $height[0];
        return $exif;
}

function get_image_geometry($file)
{
        global $configs;

	$command = $configs['identify_bin'] . ' "' . $file . '"';
	exec($command, $output, $rc);
	if ($rc != 0)
		return false; // couldnt fetch image data

	$image_info = explode(' ', substr($output[0], strlen($file) + 1));
	$geometry = explode('+', $image_info[1]);
        return $geometry[0];
}

function check_album_in_db($album_id)
{
        global $db;
        $cur_dir = getcwd();
	$sql = "SELECT * FROM albums
		WHERE id='" . $album_id . "'";
	if (!($result = $db->sql_query($sql)))
	{
		msg_die("Can't get query albums table", '', __FILE__, __LINE__, $sql);
	}
	if (!($row = $db->sql_fetchrow($result)))
        {
                // album was not found from the db
                $sql = "INSERT INTO albums (id, directory, created)
                        VALUES ('" . $album_id . "',
                                '" . $cur_dir . "',
                                now())";
		if (!($result = $db->sql_query($sql)))
		{
			msg_die("Error inserting data to albums table", '', __FILE__, __LINE__, $sql);
		}
                // all done then
                return;
        }
        if ($row['directory'] != $cur_dir)
        {
                // there is different directory in db with this albumid
                // lets fix
                $sql = "UPDATE albums SET
                        directory = '" . $cur_dir . "'
                        WHERE id = '" . $album_id . "'";
		if (!($result = $db->sql_query($sql)))
		{
			msg_die("Error updating albums data", '', __FILE__, __LINE__, $sql);
		}
        }
}

function image_link($image)
{
	$link = str_replace("#", "%23", $image);
	return $link;
}


?>
